package cn.estsh.i3plus.pojo.wms.bean.health;

import lombok.Getter;
import lombok.Setter;


/**
 * 健康度指标变量
 */
@Getter
public class WmsHealthIndexVariable {

    /**
     * 指标变量代码
     */
    private final WmsHealthIndexVariableId id;

    /**
     * 指标变量名称
     */
    @Setter
    private String name;
    /**
     * 计算周期
     */
    @Setter
    private IWmsHealthIndexCron cycleRange;

    /**
     * 计算频次
     */
    @Setter
    private IWmsHealthIndexCron calcFrequency;

    /**
     * 计算方式
     */
    @Setter
    private WmsHealthIndexCalcWay calcWay;

    /**
     * 适应存储区
     */
    @Setter
    private String applyArea;

    /**
     * 适应物料组
     */
    @Setter
    private String applyPartGroup;

    @Setter
    private String sqlStatement;

    @Setter
    private String className;

    @Setter
    private String functionName;

    @Setter
    private String scriptNo;
    /**
     * 计算值
     */
    @Setter
    private Object value;

    /**
     * 修改CRON，计算周期、频次需要刷新数据
     */
    @Setter
    private boolean refresh;

    public WmsHealthIndexVariable(String organizeCode,String variable){
        this(new WmsHealthIndexVariableId(organizeCode,variable));
    }

    public WmsHealthIndexVariable(WmsHealthIndexVariableId id){
        this.id = id;
    }

    /**
     * 是否需要计算（在CRON表达式内）
     * @param expectDifference 期待的时间差，前后多少秒
     * @return
     */
    public boolean isNeedCalc(int expectDifference){
        boolean flag = calcFrequency.verify(expectDifference);
                flag |= calcFrequency.verify(-expectDifference);
        return flag;
    }

    public boolean checked(){
        return null!=value;
    }

    public void changeCalcFrequency(IWmsHealthIndexCron cron){
        setCalcFrequency(cron);
        setRefresh(true);
    }

    public void changeCycleRange(IWmsHealthIndexCron cron){
        setCycleRange(cron);
        setRefresh(true);
    }
}
